#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>

using namespace std;

#define MAXN 1111
#define MAXR 1111111
#define MAXD 5

int D, U, V;

// Pozice v retezci a, pozice v retezci b (relativne vzhledem k a posunuta o D + 1)
int mem_dist[MAXR][2 * MAXD + 2];
int dist (char *a, int A, char *b, int B) {

  if (abs(A - B) > D) return D + 1;

  for (int i = 0; i < A + 1; ++i) {
    for (int j = 0; j <= 2 * D + 1; ++j) {
      mem_dist[i][j] = D + 1;
    }
  }
  
  /*
  printf("A: %d B: %d\n", A, B);
  for(int i = 0; i < A; ++i) printf("%c", a[i]); printf("\n");
  for(int i = 0; i < B; ++i) printf("%c", b[i]); printf("\n");
  */

  mem_dist[0][D + 1] = 0;
  for (int pos_a = 0; pos_a <= A; ++pos_a) {
    for (int diff = 0; diff <= 2 * D + 1; ++diff) if (mem_dist[pos_a][diff] != D + 1) {
      int pos_b = pos_a + diff - (D + 1);
      // if (mem_dist[pos_a][diff] != D + 1) printf("pos_a: %d pos_b: %d diff:%d mem_dist: %d\n", pos_a, pos_b, diff, mem_dist[pos_a][diff]);
      if (pos_a < A && diff > 0) 
        mem_dist[pos_a + 1][diff - 1] = min(
	  mem_dist[pos_a + 1][diff - 1],
	  mem_dist[pos_a][diff] + 1
	);
      if (pos_b < B && diff < 2 * D + 1)
        mem_dist[pos_a][diff + 1] = min(
	  mem_dist[pos_a][diff + 1],
	  mem_dist[pos_a][diff] + 1
	);
      if (pos_a < A && pos_b < B)
        mem_dist[pos_a + 1][diff] = min(
	  mem_dist[pos_a + 1][diff],
	  mem_dist[pos_a][diff] + (a[pos_a] != b[pos_b])
	);
    }
  }

  return mem_dist[A][B - A + D + 1];
}

char *fragment[MAXN];
char r[MAXR], tmp[MAXR];
int F[MAXN], R, TMP; // Delky prislusnych "malych" retezcu

#define MAXM 30 // Maximalne 26 sousedu kazdeho fragmentu
int graph[MAXN][MAXM], G[MAXN];

int seq[MAXR], S = 0;
bool dfs(int pos, int d, int last) {
  // for (int i = 0; i < S; ++i) printf("  ");
  // printf("pos: %d d: %d last: %d\n", pos, d, last);
  if (d > D) return false;
  if (pos == R) {
    if (last != V) return false;
    for (int i = 0; i < S; ++i) {
      if (i) printf(" ");
      printf("%d", seq[i] + 1);
    }
    printf("\n");
    return true;
  }
  
  for (int i = 0; i < G[last]; ++i) {
    int x = graph[last][i];
    for (int diff = -D + d; diff <= D - d; diff++) {
      if (F[x] + diff < 0 || F[x] + diff + pos > R) continue;
      seq[S++] = x;
      if (dfs(pos + F[x] + diff, d + dist(fragment[x], F[x], r + pos, F[x] + diff), x)) {
        return true;
      }
      S--;
    }
  }

  return false;
}

int main() {
  int N, M;
  scanf("%d%d", &N, &M);
  for (int i = 0; i < N; ++i) {
    scanf("%s", tmp);
    TMP = strlen(tmp);
    fragment[i] = (char *)malloc(sizeof(char) * (TMP + 1));
    for (int j = 0; j < TMP; ++j) fragment[i][j] = tmp[j];
    F[i] = TMP;
  }

  for (int i = 0; i < M; ++i) {
    int a, b;
    scanf("%d%d", &a, &b); --a; --b;
    graph[a][G[a]++] = b;
  }

  scanf("%d%d%d", &D, &U, &V); U--; V--;

  scanf("%s", r);
  R = strlen(r);

  seq[S++] = U;
  for (int diff = -D; diff <= D; diff++) {
    if (F[U] + diff < 0 || F[U] + diff > R) continue;
    if (dfs(F[U] + diff, dist(fragment[U], F[U], r, F[U] + diff), U)) {
      return 0;
    }
  }
  printf("-1\n");

  return 0;
}
